<?php
/**
 * @package shippingMethod
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: raccomandatapostale.php 4184 2006-08-21 03:36:36Z ajeh $
 */
/**
 * Enter description here...
 *
 */
class raccomandatapostale extends base {
  /**
   * Enter description here...
   *
   * @var unknown_type
   */
  var $code;
  /**
   * Enter description here...
   *
   * @var unknown_type
   */
  var $title;
  /**
   * Enter description here...
   *
   * @var unknown_type
   */
  var $description;
  /**
   * Enter description here...
   *
   * @var unknown_type
   */
  var $icon;
  /**
   * Enter description here...
   *
   * @var unknown_type
   */
  var $enabled;
  /**
   * Enter description here...
   *
   * @return raccomandatapostale
   */
  function raccomandatapostale() {
    global $order, $db;

    $this->code = 'raccomandatapostale';
    $this->title = MODULE_SHIPPING_RACCOMANDATAPOSTALE_TEXT_TITLE;
    $this->description = MODULE_SHIPPING_RACCOMANDATAPOSTALE_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_SHIPPING_RACCOMANDATAPOSTALE_SORT_ORDER;
    $this->icon = '';
    $this->tax_class = MODULE_SHIPPING_RACCOMANDATAPOSTALE_TAX_CLASS;
    $this->tax_basis = MODULE_SHIPPING_RACCOMANDATAPOSTALE_TAX_BASIS;
    // disable only when entire cart is free shipping
    if (zen_get_shipping_enabled($this->code)) {
      $this->enabled = ((MODULE_SHIPPING_RACCOMANDATAPOSTALE_STATUS == 'True') ? true : false);
    }
    


    if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_RACCOMANDATAPOSTALE_ZONE > 0) ) {
      $check_flag = false;
      $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_RACCOMANDATAPOSTALE_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
      while (!$check->EOF) {
        if ($check->fields['zone_id'] < 1) {
          $check_flag = true;
          break;
        } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
          $check_flag = true;
          break;
        }
        $check->MoveNext();
      }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    }
  }
  /**
   * Enter description here...
   *
   * @param unknown_type $method
   * @return unknown
   */
  function quote($method = '') {
    global $order, $shipping_weight, $shipping_num_boxes, $total_count;
    

    // shipping adjustment
    switch (MODULE_SHIPPING_RACCOMANDATAPOSTALE_MODE) {
      case ('price'):
        $order_total = $_SESSION['cart']->show_total() - $_SESSION['cart']->free_shipping_prices() ;
        break;
      case ('weight'):
        $order_total = $shipping_weight;
        break;
      case ('item'):
        $order_total = $total_count - $_SESSION['cart']->free_shipping_items();
        break;
    }

    $raccomandatapostale_cost = split("[:,]" , MODULE_SHIPPING_RACCOMANDATAPOSTALE_COST);
    $size = sizeof($raccomandatapostale_cost);
    for ($i=0, $n=$size; $i<$n; $i+=2) {
      if (round($order_total,9) <= $raccomandatapostale_cost[$i]) {
        $shipping = $raccomandatapostale_cost[$i+1];
        break;
      }
    }
    	/*ora impostiamo il limite massimo per questo tipo di spedizione es 100kg*/
    if ($shipping_weight<100){
    if (MODULE_SHIPPING_RACCOMANDATAPOSTALE_MODE == 'weight') {
      $shipping = $shipping * $shipping_num_boxes;
      // show boxes if weight
      switch (SHIPPING_BOX_WEIGHT_DISPLAY) {
        case (0):
        $show_box_weight = '';
        break;
        case (1):
        $show_box_weight = ' (' . $shipping_num_boxes . ' ' . TEXT_SHIPPING_BOXES . ')';
        break;
        case (2):
        $show_box_weight = ' (' . number_format($shipping_weight * $shipping_num_boxes,2) . TEXT_SHIPPING_WEIGHT . ')';
        break;
        default:
        $show_box_weight = ' (' . $shipping_num_boxes . ' x ' . number_format($shipping_weight,2) . TEXT_SHIPPING_WEIGHT . ')';
        break;
      }
    }


    $this->quotes = array('id' => $this->code,
    'module' => MODULE_SHIPPING_RACCOMANDATAPOSTALE_TEXT_TITLE . $show_box_weight,
    'methods' => array(array('id' => $this->code,
    'title' => MODULE_SHIPPING_RACCOMANDATAPOSTALE_TEXT_WAY,
    'cost' => $shipping + MODULE_SHIPPING_RACCOMANDATAPOSTALE_HANDLING)));

    if ($this->tax_class > 0) {
      $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
    }
}
    if (zen_not_null($this->icon)) $this->quotes['icon'] = zen_image($this->icon, $this->title);

    return $this->quotes;
  }
  /**
   * Enter description here...
   *
   * @return unknown
   */
  function check() {
    global $db;
    if (!isset($this->_check)) {
      $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_STATUS'");
      $this->_check = $check_query->RecordCount();
    }
    return $this->_check;
  }
  /**
   * Enter description here...
   *
   */
  function install() {
    global $db;
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Raccomandata postale', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_STATUS', 'True', 'Attivare Raccomandata Postale come metodo di spedizione?<p>(true-Si; false-No)</p>', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Spedizione con Raccomandata postale', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_COST', '3:9,15:11,30:12,50:25', 'TIl costo della spedizione  basato sul totale dovuto o sul peso dei prodotti o sulla quantit degli articoli. Esempio: 25:8.50,50:5.50,etc.. Fino a 25Kg la spedizione sar di  8.50, invece fino a 50Kg la spedizione coster  5.50, etc', '6', '0', 'zen_cfg_textarea(', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Criterio raccomandata postale', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_MODE', 'weight', 'La spedizione pu essere calcolata sul costo totale degli articoli o sul peso totale degli articoli o  sul numero totale degli articoli. <p>(weight = peso; price = prezzo; item = articolo)</p>', '6', '0', 'zen_cfg_select_option(array(\'weight\', \'price\', \'item\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Tassa Consegna', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_HANDLING', '0', 'Specificare la tassa per la consegna.', '6', '0', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Aliquota IVA', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_TAX_CLASS', '0', 'Selezionare aliquota IVA per la spedizione.', '6', '0', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Base Tassa', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_TAX_BASIS', 'Shipping', 'OSu quale base  calcolata la tasse per la spedizione. Le opzioni sono<br />Spedizione - Basata sulla destinazione della spedizione del cliente<br />Fatturazione basata sulla destinazione del cliente<br />Magazzino - Basata sull indirizzo del magazzino se la fattra e la destinazione appartengono alla stesso paese.<p>(Shipping = Spedizione; Billing = Fattura; Store = Magazzino)</p>', '6', '0', 'zen_cfg_select_option(array(\'Shipping\', \'Billing\', \'Store\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Paese di Spedizione', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_ZONE', '0', 'Abilita la spedizione solo per il paese selezionato.', '6', '0', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Ordine visualizzazione', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_SORT_ORDER', '0', 'Ordine visualizzazione sulla schermo.', '6', '0', now())");
  }
  /**
   * Enter description here...
   *
   */
  function remove() {
    global $db;
    $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }
  /**
   * Enter description here...
   *
   * @return unknown
   */
  function keys() {
    return array('MODULE_SHIPPING_RACCOMANDATAPOSTALE_STATUS', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_COST', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_MODE', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_HANDLING', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_TAX_CLASS', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_TAX_BASIS', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_ZONE', 'MODULE_SHIPPING_RACCOMANDATAPOSTALE_SORT_ORDER');
  }
}
?>